'                                WIZGUI ZX
'                              Ver: 1.5 Alfa
'                         Made by Albert Varaksin
'
'Relise Notes
'
'  WizGui ZX is freeware so you ca do with it whatever you want!
'Ofcourse it would be nice if you write a program with it and tell
'that you used a wizGui library.
'
'What's new
'
'  - Known bugs are repeared
'  - 16 and 32 bit color support added
'  - Color themes suport added
'  - Windowing system improved -so it is faster and more reliable
'    Swich between windows easely by pressing tabulator or
'    close window by pressing F4 or close button on the title bar.
'    Olso you can hide windows by calling HideWindow(s) function and
'    by ShowWindow(s) function you can bring window back to screen.
'  - Stability improved
'  - Button system improved so it works faster.
'  - Added Drawing functions:
'    BMP2Window - allow you easily load Bmp fail into selected window
'    DrawPset - Draw's a dot into selected window
'  - More easy to use
'  - It takes less memory


'$INCLUDE: 'future.bi'
'ͻ
'---Declarin WizGui ZX routines---
'ͼ
'Declaring main system routines
'
DECLARE SUB Initalise ()
DECLARE SUB CheckSystem ()
DECLARE SUB RunSystem ()
DECLARE SUB ReFreshScreen ()
DECLARE SUB RunProcess ()
DECLARE SUB DetectProcess ()
DECLARE SUB Controls ()
DECLARE SUB EndGui ()
DECLARE FUNCTION GetColor& (Number%)
DECLARE FUNCTION ThemeColor& (Unit$)
DECLARE FUNCTION WizGuiVersion$ ()
DECLARE FUNCTION WizGuiCodeName$ ()

'Declaring windowing system routines
'
DECLARE SUB SetWindow (Xpos%, Ypos%, XSize%, YSize%, Title$, WinID%)
DECLARE SUB CloseWindow (WinID%)
DECLARE SUB WindowSystem ()
DECLARE SUB GetActiveWindow ()
DECLARE SUB SetActiveWindow (WinID%)
DECLARE SUB WindowControls ()
DECLARE SUB MoveWindow (WinID%)
DECLARE SUB DrawWindow (Style%, WinID%)
DECLARE SUB GetMask (Target%, WinID%)
DECLARE SUB PutMask (Target%, WinID%)
DECLARE SUB DefWin (WinID%)
DECLARE SUB EndDefWin ()
DECLARE SUB HideWindow (WinID%)
DECLARE SUB HideWindows ()
DECLARE SUB ShowWindow (WinID%)
DECLARE SUB ShowWindows ()
DECLARE SUB ReFreshWindows ()
DECLARE SUB DeleteWindowContents (WinID%)
DECLARE FUNCTION FreeWindow% ()
DECLARE FUNCTION WinX% (WinID%)
DECLARE FUNCTION WinX1% (WinID%)
DECLARE FUNCTION WinY% (WinID%)
DECLARE FUNCTION WinY1% (WinID%)
DECLARE FUNCTION X% (WinID%)
DECLARE FUNCTION Y% (WinID%)
DECLARE FUNCTION X1% (WinID%)
DECLARE FUNCTION Y1% (WinID%)
DECLARE FUNCTION WinXSize% (WinID%)
DECLARE FUNCTION WinYSize% (WinID%)

'Declaring button system routines
'
DECLARE SUB SetButton (Xpos%, Ypos%, Title$, WinID%, ButID%)
DECLARE SUB SetAdvButton (Xpos%, Ypos%, XSize%, YSize%, Title$, WinID%, ButID%)
DECLARE SUB DrawButton (Style%, WinID%, ButID%)
DECLARE SUB ButtonSystem ()
DECLARE SUB DefBut (WinID%, ButID%)
DECLARE SUB EndDefBut ()
DECLARE SUB BMP2Button (File$, Xpos, Ypos, WinID%, ButID%)
DECLARE SUB DeleteButton (WinID%, ButID%)

'Declaring Textbox system routines
'
DECLARE SUB SetTextBox (Xpos%, Ypos%, Lenght%, WinID%, TbID%)
DECLARE SUB TextBoxSystem ()
DECLARE SUB DeleteTextBox (WinID%, TbID%)


'Declaring Text system routines
'
DECLARE SUB SetTextLoc (Xpos%, Ypos%, WinID%)
DECLARE SUB SetTextColor (FColor&, BColor&)
DECLARE SUB SetText (Text$)
DECLARE SUB SetSmartTextArea (Xpos%, X1pos%, WinID%)
DECLARE SUB SetSmartText (Text$)
DECLARE SUB SetTextFont (File$)

'Declaring drawing routines
'
DECLARE SUB PaintWin (C&, WinID%)
DECLARE SUB DrawBox (Xpos%, Ypos%, XSize%, YSize%, C&, WinID%)
DECLARE SUB DrawBox3D (Xpos%, Ypos%, XSize%, YSize%, Style%, WinID%)
DECLARE SUB DrawFillBox (Xpos%, Ypos%, XSize%, YSize%, C&, WinID%)
DECLARE SUB DrawFillBox3D (Xpos%, Ypos%, XSize%, YSize%, Style%, C&, WinID%)
DECLARE SUB DrawCircle (Xpos%, Ypos%, R%, C&, WinID%)
DECLARE SUB DrawFillCircle (Xpos%, Ypos%, R%, C&, WinID%)
DECLARE SUB DrawLine (Xpos%, Ypos%, X1pos%, Y1pos%, C&, WinID%)
DECLARE SUB DrawHLine (Xpos%, Ypos%, XLenght%, C&, WinID%)
DECLARE SUB DrawVLine (Xpos%, Ypos%, YLenght%, C&, WinID%)
DECLARE SUB DrawHLine3D (Xpos%, Ypos%, XLenght%, WinID%)
DECLARE SUB DrawVLine3D (Xpos%, Ypos%, YLenght%, WinID%)
DECLARE SUB DrawPset (Xpos%, Ypos%, C&, WinID%)
DECLARE SUB BMP2Window (FailName$, Xpos%, Ypos%, WinID%)

'ͻ
'---Setting up WizGui ZX variables---
'ͼ
CONST True% = -1, False% = 0
COMMON SHARED ReFresh%, key$, Xres%, Yres%, Deph%, Theme$
COMMON SHARED InProcess%, ProcessID%
COMMON SHARED MouseX%, MouseY%, MouseL%, MouseR%, OldMouseX%, OldMouseY%
COMMON SHARED NofW%, WinCount%, ActiveWin%, border%, head%, SWCWD%
COMMON SHARED NofB%, NofTb%, SmTXpos%, SmTX1pos%, TextFont$, TempWinID%, TempControlID%, TempControlType%
COMMON SHARED XChange%, YChange%, X1Change%, Y1Change%, OldX%, OldY%
COMMON SHARED CursorX%, CursorY%, CursorWinID%, TextBgColor&, TextFgColor&

TYPE WindowVariables
   Order AS INTEGER
   Status AS INTEGER
   Xpos AS INTEGER
   Ypos AS INTEGER
   X1pos AS INTEGER
   Y1pos AS INTEGER
   BackMask AS INTEGER
   IntMask AS INTEGER
   Title AS STRING * 15
   WinID AS INTEGER
   NofB AS INTEGER
   NofTb AS INTEGER
   DisableCloseOption AS INTEGER
END TYPE
TYPE ButtonVariables
   Xpos AS INTEGER
   Ypos AS INTEGER
   XSize AS INTEGER
   YSize AS INTEGER
   ButID AS INTEGER
   WinID AS INTEGER
   Status AS INTEGER
END TYPE
TYPE TextBoxVariables
   Status AS INTEGER
   Xpos AS INTEGER
   Ypos AS INTEGER
   X1pos AS INTEGER
   Y1pos AS INTEGER
   WinID AS INTEGER
   Lenght AS INTEGER
   PasswordType AS INTEGER
END TYPE
COMMON SHARED win() AS WindowVariables
COMMON SHARED WinDataBase()
COMMON SHARED But() AS ButtonVariables
COMMON SHARED Tb() AS TextBoxVariables
COMMON SHARED TbText() AS STRING
COMMON SHARED ButText() AS STRING

RANDOMIZE TIMER

'ͻ
'---Setting WizGui ZX preferences---
'ͼ
'NofW.....Maximum number of windows aviable on the screen at one time
'NofB.....Maximum number of buttons aviable in one window at one time
'NofTb....Maximum number of textboxes aviable in one window at one time
'Border...Window Border% size -try larger:)
'Head.....Size of window title -again you can try larger:)
'Theme$...Color theme (data is stored in the external fail with .wgt
'         extension) used for drawing windows.
'         If theme is not set then internal built-in theme will be
'         used. Themes can only be used if color Deph% is at least 16 bit!
'Deph.....Color Deph% (bit) 16 - optimal Aviable Color dephs:
'         8 bit - 256 colors
'         16 bit - 65536 colors
'         32 bit about 16 million colors
'         NB! some of color Deph%'s you video card may not support,
'         in that case just set an lower one.
'SWCWD....Show window contents while dragging.
'         If True% then it shows whole window when you dragg it,
'         if False% then not. True% is recommendable only for faster
'         computers (at least PII 233MHz) or it may slow
'         down WizGui work (but not necceceraly).
'
'Xres% and Yres% - sets screen resolution.
'Resolution table:
'  Xres    Yres
'
'  300     200
'  320     240
'  512     384
'  640     400
'  640     480
'  800     600
'  1024    768
'  1280    1024
'  1600    1200
'NB! Xres% and Yres% must be used in pair.
'For example if Xres% is 800 then Yres% must be 600
'
'Some of these may not work on your computer. It depends on your
'video card VESA supprt. Be careful with larger resolution then
'800 x 600 becouse your monitor may not support it even if your video
'card does! In that case just set lower resolution.

NofW% = 10
NofB% = 10
NofTb% = 10
border% = 4
head% = 18
Deph% = 16'........[ 8 | 16 | 24 | 32 ]
Theme$ = "uw.wgt"
SWCWD% = False'....[ False | True ]
Xres% = 800
Yres% = 600

DIM SHARED win(NofW%) AS WindowVariables
DIM SHARED WinDataBase(NofW%)
DIM SHARED But(NofW%, NofB%) AS ButtonVariables
DIM SHARED Tb(NofW%, NofTb%) AS TextBoxVariables
DIM SHARED TbText(NofW%, NofTb%) AS STRING
DIM SHARED ButText(NofW%, NofB%) AS STRING
'Starting WizGui ZX
'
Initalise

'ͻ
'---Your program code start's here---
'ͼ
'..............................................
DO
RunSystem
LOOP UNTIL key$ = CHR$(27)
'..............................................
'ͻ
'---Your program code end's here---
'ͼ
'ending WizGui ZX
'
EndGui
CLEAR

SUB BMP2Button (File$, Xpos, Ypos, WinID%, ButID%)
IF WinID% <> ActiveWin THEN EXIT SUB
IF File$ > "" THEN
   Xpos% = Xpos% + X%(WinID%) + But(WinID%, ButID%).Xpos%
   Ypos% = Ypos% + Y%(WinID%) + But(WinID%, ButID%).Ypos%
   Future.LoadBMP File$, Xpos, Ypos
END IF
END SUB

SUB BMP2Window (FailName$, Xpos%, Ypos%, WinID%)
IF WinID% = ActiveWin% THEN
   Xpos% = Xpos% + X%(WinID%)
   Ypos% = Ypos% + Y%(WinID%)
   Future.LoadBMP FailName$, Xpos%, Ypos%
END IF
END SUB

SUB ButtonSystem
'---ButtonSystem Sub Ver: 1.0---'
'When you press mouse button then this sub detect's wether you
'pressed it on the button of the active window or not.
'If yes then it returns InProcess% value 4 and to ProcessID% Button ID

IF ActiveWin% < 1 THEN EXIT SUB
IF win(ActiveWin%).NofB = 0 THEN EXIT SUB
WinID% = ActiveWin%
FOR ButID% = 1 TO NofB%
   IF But(WinID%, ButID%).Status% > 0 THEN
      IF But(WinID%, ButID%).WinID% = WinID% THEN
         Xpos% = But(WinID%, ButID%).Xpos% + X%(WinID%)
         Ypos% = But(WinID%, ButID%).Ypos% + Y%(WinID%)
         X1pos% = But(WinID%, ButID%).Xpos% + X%(WinID%) + But(WinID%, ButID%).XSize%
         Y1pos% = But(WinID%, ButID%).Ypos% + Y%(WinID%) + But(WinID%, ButID%).YSize%
         IF MouseX% > Xpos% THEN
            IF MouseX% < X1pos% THEN
               IF MouseY% > Ypos% THEN
                  IF MouseY% < Y1pos% THEN
                     InProcess% = 4
                     ProcessID% = ButID%
                     DrawButton 2, WinID%, ButID%
                     EXIT SUB
                  END IF
               END IF
            END IF
         END IF
      END IF
   END IF
NEXT
END SUB

DEFSNG A-Z
SUB CheckSystem
CLS : COLOR 7, 0
'---CheckSystem Sub Ver: 1.0---'
'This routine check's that are Vesa Support, Ems memory support and
'Xms memory support exist. They are neede in order to run WizGui
IF IsVESA = False% THEN Error$ = Error$ + "100:001 -> Vesa support not found!" + CHR$(13)
IF IsEMMInstalled = False% THEN Error$ = Error$ + "100:002 -> EMS memory not found!" + CHR$(13)
IF IsXMSInstalled = False% THEN Error$ = Error$ + "100:003 -> XMS memory not found!" + CHR$(13)
IF Error$ > "" THEN
   PRINT Error$
   END
END IF
END SUB

DEFINT A-Z
SUB CloseWindow (WinID%)
'---CloseWindow Sub Ver: 1.1---'
'This routine closes specific window by window's ID (WinID%)
SetActiveWindow WinID%
DeleteWindowContents WinID%
id = WinID%
PutMask 1, id
WinCount% = WinCount% - 1
win(WinID%).Order% = 0
win(WinID%).Status% = 0
win(WinID%).Xpos% = 0
win(WinID%).Ypos% = 0
win(WinID%).X1pos% = 0
win(WinID%).Y1pos% = 0
win(WinID%).Title = ""
win(WinID%).WinID% = 0
win(WinID%).NofB = 0
DeallocateXMS win(id).BackMask%
DeallocateXMS win(id).IntMask%
ActiveWin% = 0
END SUB

SUB Controls
'---Controls Sub Ver: 1.0---'
'This sub updates and gets mouse and keyboard values
key$ = INKEY$
OldMouseX% = MouseX%
OldMouseY% = MouseY%
Future.UpdateMouse
MouseX% = Future.MouseX
MouseY% = Future.MouseY
MouseL% = (Future.MouseB AND 1) = 1
MouseR% = (Future.MouseB AND 2) = 2
IF OldMouseX% = MouseX% AND OldMouseY% = MouseY% AND key$ = "" THEN
   ScreenSaverTimer = ScreenSaverTimer
END IF
END SUB

SUB DefBut (WinID%, ButID%)
IF WinID% = ActiveWin% AND But(WinID%, ButID%).Status% > 0 THEN
   Xpos% = But(WinID%, ButID%).Xpos% + X%(WinID%) + 2
   Ypos% = But(WinID%, ButID%).Ypos% + Y%(WinID%) + 2
   X1pos% = But(WinID%, ButID%).Xpos% + X%(WinID%) + But(WinID%, ButID%).XSize% - 2
   Y1pos% = But(WinID%, ButID%).Ypos% + Y%(WinID%) + But(WinID%, ButID%).YSize% - 2
   IF X1pos% > X1%(WinID%) THEN X1pos% = X1%(WinID%)
   IF Y1pos% > Y1%(WinID%) THEN Y1pos% = Y1%(WinID%)
   SetViewPort Xpos%, Ypos%, X1pos% + 1, Y1pos% + 1
END IF
END SUB

SUB DefWin (WinID%)
'Start's window defination cycle
IF WinID% > 0 THEN
   DefProcess = 1
   IF WinID% <> ActiveWin% THEN SetActiveWindow WinID%
   SetViewPort X%(WinID%), Y%(WinID%), X1%(WinID%) + 1, Y1%(WinID%) + 1
END IF
END SUB

SUB DeleteButton (WinID%, ButID%)
'Deletes button by ButID in window by WinID
IF But(WinID%, ButID%).Status% > 0 THEN
   But(WinID%, ButID%).Xpos% = 0
   But(WinID%, ButID%).Ypos% = 0
   But(WinID%, ButID%).XSize% = 0
   But(WinID%, ButID%).YSize% = 0
   But(WinID%, ButID%).ButID% = 0
   But(WinID%, ButID%).WinID% = 0
   But(WinID%, ButID%).Status% = 0
END IF
END SUB

SUB DeleteTextBox (WinID%, TbID%)
'Deletes specific textbox
IF Tb(WinID%, TbID%).Status% > 0 THEN
   Tb(WinID%, TbID%).Status% = 0
   Tb(WinID%, TbID%).Xpos% = 0
   Tb(WinID%, TbID%).Ypos% = 0
   Tb(WinID%, TbID%).X1pos% = 0
   Tb(WinID%, TbID%).Y1pos% = 0
   Tb(WinID%, TbID%).WinID% = 0
   Tb(WinID%, TbID%).Lenght% = 0
   TbText(WinID%, TbID%) = ""
END IF

END SUB

SUB DeleteWindowContents (WinID%)
'Deletes specific window contents
IF win(WinID%).Status <> 0 THEN
   DefWin WinID%
      IF win(WinID%).NofB% > 0 THEN
         FOR Count = 1 TO NofB%
            IF But(WinID%, Count).Status > 0 THEN DeleteButton WinID%, Count
         NEXT
      END IF
      IF win(WinID%).NofTb% > 0 THEN
         FOR Count = 1 TO NofTb%
            IF Tb(WinID%, Count).Status > 0 THEN DeleteTextBox WinID%, Count
         NEXT
      END IF
      PaintWin ThemeColor("ButtonFace"), WinID%
   EndDefWin
END IF

END SUB

SUB DetectProcess
'This Sub detect's WizGui processes. Like moving windows, pressing buttons etc.
WindowSystem
   IF InProcess% > 0 THEN EXIT SUB
   IF InProcess% = 3 THEN EXIT SUB
IF ActiveWin > 0 AND Inrocess = 0 THEN
   ButtonSystem
      IF InProcess% > 0 THEN EXIT SUB
   TextBoxSystem
      IF InProcess% > 0 THEN EXIT SUB
   InProcess% = 3
END IF
END SUB

SUB DrawBox (Xpos%, Ypos%, XSize%, YSize%, C&, WinID%)
IF WinID% = ActiveWin% THEN
   Xpos% = Xpos% + X%(WinID%)
   Ypos% = Ypos% + Y%(WinID%)
   X1pos% = Xpos% + XSize%: Y1pos% = Ypos% + YSize%
   Future.BOX Xpos%, Ypos%, X1pos%, Y1pos%, C&
END IF
END SUB

SUB DrawBox3D (Xpos%, Ypos%, XSize%, YSize%, Style%, WinID%)
IF WinID% = ActiveWin% THEN
   Xpos% = Xpos% + X%(WinID%)
   Ypos% = Ypos% + Y%(WinID%)
   X1pos% = Xpos% + XSize%: Y1pos% = Ypos% + YSize%
   IF Style% = 1 THEN
      Future.LINE Xpos%, Ypos%, X1pos% - 1, Ypos%, ThemeColor("ButtonShadow"), -1
      Future.LINE Xpos%, Ypos%, Xpos%, Y1pos% - 1, ThemeColor("ButtonShadow"), -1
      Future.LINE Xpos%, Y1pos%, X1pos%, Y1pos%, ThemeColor("ButtonHiLight"), -1
      Future.LINE X1pos%, Ypos%, X1pos%, Y1pos%, ThemeColor("ButtonHiLight"), -1
   END IF
   IF Style% = 2 THEN
      Future.LINE Xpos%, Ypos%, X1pos% - 1, Ypos%, ThemeColor("ButtonHiLight"), -1
      Future.LINE Xpos%, Ypos%, Xpos%, Y1pos% - 1, ThemeColor("ButtonHiLight"), -1
      Future.LINE Xpos%, Y1pos%, X1pos%, Y1pos%, ThemeColor("ButtonShadow"), -1
      Future.LINE X1pos%, Ypos%, X1pos%, Y1pos%, ThemeColor("ButtonShadow"), -1
   END IF
END IF
END SUB

SUB DrawButton (Style%, WinID%, ButID%)
IF But(WinID%, ButID%).WinID% = ActiveWin% THEN
   Xpos% = X%(WinID%) + But(WinID%, ButID%).Xpos%
   Ypos% = Y%(WinID%) + But(WinID%, ButID%).Ypos%
   X1pos% = Xpos% + But(WinID%, ButID%).XSize%
   Y1pos% = Ypos% + But(WinID%, ButID%).YSize%
   IF Style% = 1 THEN
      Future.FILLBOX Xpos%, Ypos%, X1pos%, Y1pos%, ThemeColor("ButtonFace")

      Future.LINE Xpos%, Ypos%, X1pos% - 1, Ypos%, ThemeColor("ButtonHiLight"), -1
      Future.LINE Xpos%, Ypos%, Xpos%, Y1pos% - 1, ThemeColor("ButtonHiLight"), -1

      Future.LINE Xpos% + 1, Ypos% + 1, X1pos% - 2, Ypos% + 1, ThemeColor("ButtonLight"), -1
      Future.LINE Xpos% + 1, Ypos% + 1, Xpos% + 1, Y1pos% - 2, ThemeColor("ButtonLight"), -1

      Future.LINE Xpos%, Y1pos%, X1pos%, Y1pos%, ThemeColor("ButtonDkShadow"), -1
      Future.LINE X1pos%, Ypos%, X1pos%, Y1pos%, ThemeColor("ButtonDkShadow"), -1

      Future.LINE Xpos% + 1, Y1pos% - 1, X1pos% - 1, Y1pos% - 1, ThemeColor("ButtonShadow"), -1
      Future.LINE X1pos% - 1, Ypos% + 1, X1pos% - 1, Y1pos% - 1, ThemeColor("ButtonShadow"), -1

      Title$ = RTRIM$(LTRIM$(ButText(WinID%, ButID%)))
      TextX = Xpos%
      TextX = TextX + (X1pos% - Xpos%) / 2
      TextX = TextX - LEN(Title$) * 4
      TextY = Ypos%
      TextY = TextY + (But(WinID%, ButID%).YSize% / 2)
      TextY = TextY - 7
      IF TextFont$ > "" THEN Future.LoadFONT TextFont$
      Future.PRINT TextX, TextY, Title$, ThemeColor("ButtonText"), -1
      SetFont 1
   END IF
   IF Style% = 2 THEN
      'DefWin WinID%
      Future.LINE Xpos%, Ypos%, X1pos%, Ypos%, ThemeColor("ButtonDkShadow"), -1
      Future.LINE Xpos%, Ypos%, Xpos%, Y1pos%, ThemeColor("ButtonDkShadow"), -1

      Future.LINE Xpos% + 1, Y1pos%, X1pos%, Y1pos%, ThemeColor("ButtonHiLight"), -1
      Future.LINE X1pos%, Ypos% + 1, X1pos%, Y1pos%, ThemeColor("ButtonHiLight"), -1

      Future.LINE Xpos% + 1, Y1pos% - 1, X1pos% - 1, Y1pos% - 1, ThemeColor("ButtonLight"), -1
      Future.LINE X1pos% - 1, Ypos% + 1, X1pos% - 1, Y1pos% - 1, ThemeColor("ButtonLight"), -1

      Future.LINE Xpos% + 1, Ypos% + 1, X1pos% - 1, Ypos% + 1, ThemeColor("ButtonShadow"), -1
      Future.LINE Xpos% + 1, Ypos% + 1, Xpos% + 1, Y1pos% - 1, ThemeColor("ButtonShadow"), -1
      'EndDefWin
   END IF
   IF Style% = 3 THEN
      'DefWin WinID%
      Future.LINE Xpos%, Ypos%, X1pos% - 1, Ypos%, ThemeColor("ButtonHiLight"), -1
      Future.LINE Xpos%, Ypos%, Xpos%, Y1pos% - 1, ThemeColor("ButtonHiLight"), -1

      Future.LINE Xpos% + 1, Ypos% + 1, X1pos% - 2, Ypos% + 1, ThemeColor("ButtonLight"), -1
      Future.LINE Xpos% + 1, Ypos% + 1, Xpos% + 1, Y1pos% - 2, ThemeColor("ButtonLight"), -1

      Future.LINE Xpos%, Y1pos%, X1pos%, Y1pos%, ThemeColor("ButtonDkShadow"), -1
      Future.LINE X1pos%, Ypos%, X1pos%, Y1pos%, ThemeColor("ButtonDkShadow"), -1

      Future.LINE Xpos% + 1, Y1pos% - 1, X1pos% - 1, Y1pos% - 1, ThemeColor("ButtonShadow"), -1
      Future.LINE X1pos% - 1, Ypos% + 1, X1pos% - 1, Y1pos% - 1, ThemeColor("ButtonShadow"), -1
      'EndDefWin
   END IF
END IF
END SUB

SUB DrawCircle (Xpos%, Ypos%, R%, C&, WinID%)
IF WinID% = ActiveWin% THEN
   Xpos% = Xpos% + X%(WinID%)' + R%
   Ypos% = Ypos% + Y%(WinID%)' + R%
   Future.CIRCLE Xpos%, Ypos%, R%, C&
END IF
END SUB

SUB DrawFillBox (Xpos%, Ypos%, XSize%, YSize%, C&, WinID%)
IF WinID% = ActiveWin% THEN
   Xpos% = Xpos% + X%(WinID%)
   Ypos% = Ypos% + Y%(WinID%)
   X1pos% = Xpos% + XSize%: Y1pos% = Ypos% + YSize%
   Future.FILLBOX Xpos%, Ypos%, X1pos%, Y1pos%, C&
END IF
END SUB

SUB DrawFillBox3D (Xpos%, Ypos%, XSize%, YSize%, Style%, C&, WinID%)
IF WinID% = ActiveWin% THEN
   Xpos% = Xpos% + X%(WinID%)
   Ypos% = Ypos% + Y%(WinID%)
   X1pos% = Xpos% + XSize%: Y1pos% = Ypos% + YSize%
   IF Style% = 1 THEN
      Future.LINE Xpos%, Ypos%, X1pos% - 1, Ypos%, ThemeColor("ButtonShadow"), -1
      Future.LINE Xpos%, Ypos%, Xpos%, Y1pos% - 1, ThemeColor("ButtonShadow"), -1
      Future.LINE Xpos%, Y1pos%, X1pos%, Y1pos%, ThemeColor("ButtonHiLight"), -1
      Future.LINE X1pos%, Ypos%, X1pos%, Y1pos%, ThemeColor("ButtonHiLight"), -1
      Future.FILLBOX Xpos% + 1, Ypos% + 1, X1pos% - 1, Y1pos% - 1, C&
   END IF
   IF Style% = 2 THEN
      Future.LINE Xpos%, Ypos%, X1pos% - 1, Ypos%, ThemeColor("ButtonHiLight"), -1
      Future.LINE Xpos%, Ypos%, Xpos%, Y1pos% - 1, ThemeColor("ButtonHiLight"), -1
      Future.LINE Xpos%, Y1pos%, X1pos%, Y1pos%, ThemeColor("ButtonShadow"), -1
      Future.LINE X1pos%, Ypos%, X1pos%, Y1pos%, ThemeColor("ButtonShadow"), -1
      Future.BOX Xpos% + 1, Ypos% + 1, X1pos% - 1, Y1pos% - 1, ThemeColor("ButtonFace")
      Future.FILLBOX Xpos% + 2, Ypos% + 2, X1pos% - 2, Y1pos% - 2, C&
   END IF
END IF
END SUB

SUB DrawFillCircle (Xpos%, Ypos%, R%, C&, WinID%)
IF WinID% = ActiveWin% THEN
   Xpos% = Xpos% + X%(WinID%)
   Ypos% = Ypos% + Y%(WinID%)
   Future.FILLCIRCLE Xpos%, Ypos%, R%, C&
END IF
END SUB

SUB DrawHLine (Xpos%, Ypos%, XLenght%, C&, WinID%)
IF WinID% = ActiveWin% THEN
   Xpos% = Xpos% + X%(WinID%)
   Ypos% = Ypos% + Y%(WinID%)
   X1pos% = Xpos% + XLenght%: Y1pos% = Ypos%
   Future.LINE Xpos%, Ypos%, X1pos%, Y1pos%, C&, -1
END IF
END SUB

SUB DrawHLine3D (Xpos%, Ypos%, XLenght%, WinID%)
IF WinID% = ActiveWin% THEN
   Xpos% = Xpos% + X%(WinID%)
   Ypos% = Ypos% + Y%(WinID%)
   X1pos% = Xpos% + XLenght%: Y1pos% = Ypos% + 1
   Future.LINE Xpos%, Ypos%, X1pos%, Ypos%, ThemeColor("ButtonHiLight"), -1
   Future.LINE Xpos%, Ypos%, X1pos% - 1, Ypos%, ThemeColor("ButtonShadow"), -1
   Future.LINE Xpos%, Y1pos%, X1pos%, Y1pos%, ThemeColor("ButtonHiLight"), -1
END IF
END SUB

SUB DrawLine (Xpos%, Ypos%, X1pos%, Y1pos%, C&, WinID%)
IF WinID% = ActiveWin% THEN
   Xpos% = Xpos% + X%(WinID%)
   Ypos% = Ypos% + Y%(WinID%)
   X1pos% = X1pos% + X%(WinID%)
   Y1pos% = Y1pos% + Y%(WinID%)
   Future.LINE Xpos%, Ypos%, X1pos%, Y1pos%, C&, -1
END IF
END SUB

SUB DrawPset (Xpos%, Ypos%, C&, WinID%)
IF ActiveWin% = WinID% THEN
   Xpos% = Xpos% + X%(WinID%)
   Ypos% = Ypos% + Y%(WinID%)
   Future.PSET Xpos%, Ypos%, C&
END IF
END SUB

SUB DrawVLine (Xpos%, Ypos%, YLenght%, C&, WinID%)
IF WinID% = ActiveWin% THEN
   Xpos% = Xpos% + X%(WinID%)
   Ypos% = Ypos% + Y%(WinID%)
   X1pos% = Xpos%: Y1pos% = Ypos% + YLenght%
   Future.LINE Xpos%, Ypos%, X1pos%, Y1pos%, C&, -1
END IF
END SUB

SUB DrawVLine3D (Xpos%, Ypos%, YLenght%, WinID%)
IF WinID% = ActiveWin% THEN
   Xpos% = Xpos% + X%(WinID%)
   Ypos% = Ypos% + Y%(WinID%)
   X1pos% = Xpos% + 1: Y1pos% = Ypos% + YLenght%
   Future.LINE Xpos%, Ypos%, Xpos%, Y1pos%, ThemeColor("ButtonHiLight"), -1
   Future.LINE Xpos%, Ypos%, Xpos%, Y1pos%, ThemeColor("ButtonShadow"), -1
   Future.LINE X1pos%, Ypos%, X1pos%, Y1pos%, ThemeColor("ButtonHiLight"), -1
END IF
END SUB

SUB DrawWindow (Style%, WinID%)
'---DrawWindow Sub ver: 1.2---'
'This routine draws window and close button on the window.
'Color's are use from theme fail
'There are 4 Style%s to draw:
'  5 - New Window inactive Window and close Button(Not pressed)
'  1 - inactive window and close Button(Not pressed)
'  2 - active window and close Button(Not pressed)
'  3 - Only close Button (Pressed)
'  4 - Only close Button (Not Pressed)

'Getting variables
Xpos% = WinX(WinID%)
Ypos% = WinY(WinID%)
X1pos% = WinX1(WinID%)
Y1pos% = WinY1(WinID%)
ButtonSize = head% - 6
ButX1 = X1%(WinID%) - 3: ButX = ButX1 - ButtonSize
ButY = WinY(WinID%) + border% + 3: ButY1 = ButY + ButtonSize
Title$ = LTRIM$(RTRIM$(win(WinID%).Title))

'Getting colors
InActiveBorder& = ThemeColor("InActiveBorder")
ActiveBorder& = ThemeColor("ActiveBorder")
ButtonFace& = ThemeColor("ButtonFace")
ButtonShadow& = ThemeColor("ButtonShadow")
ButtonHiLight& = ThemeColor("ButtonHilight")
ButtonLight& = ThemeColor("Buttonlight")
ButtonDkShadow& = ThemeColor("ButtonDkShadow")
ButtonText& = ThemeColor("ButtonText")

SELECT CASE Style%
   CASE 1 'Window is not active
      Future.FILLBOX Xpos%, Ypos%, X1pos%, Y1pos%, InActiveBorder&
      Title& = ThemeColor("InActiveTitle")
      TitleText& = ThemeColor("InActiveTitleText")
   CASE 2  'Window is Active
      Future.FILLBOX Xpos%, Ypos%, X1pos%, Y1pos%, ActiveBorder&
      Title& = ThemeColor("ActiveTitle")
      TitleText& = ThemeColor("TitleText")
   CASE 3
      IF win(WinID%).DisableCloseOption% = False% THEN
         Future.FILLBOX ButX, ButY, ButX1, ButY1, ButtonFace&
         Future.LINE ButX, ButY, ButX, ButY1, ButtonShadow&, -1
         Future.LINE ButX, ButY, ButX1, ButY, ButtonShadow&, -1
         Future.LINE ButX, ButY1, ButX1, ButY1, ButtonHiLight&, -1
         Future.LINE ButX1, ButY, ButX1, ButY1, ButtonHiLight&, -1
         Future.PRINT ButX + ButtonSize / 2 - 3, ButY + ButtonSize / 2 - 8, "", ButtonText&, -1
      END IF
      EXIT SUB
   CASE 4
      IF win(WinID%).DisableCloseOption% = False% THEN
         GOTO CloseButton
      END IF
END SELECT

'DrawingWindow body
Future.FILLBOX Xpos% + border%, Ypos% + border%, X1pos% - border%, Y1pos% - border%, ButtonFace&
Future.LINE Xpos% + 1, Ypos% + 1, Xpos% + 1, Y1pos% - 1, ButtonHiLight&, -1
Future.LINE Xpos% + 1, Ypos% + 1, X1pos% - 1, Ypos% + 1, ButtonHiLight&, -1
Future.LINE Xpos%, Ypos%, Xpos%, Y1pos%, ButtonLight&, -1
Future.LINE Xpos%, Ypos%, X1pos%, Ypos%, ButtonLight&, -1
Future.LINE Xpos%, Y1pos% - 1, X1pos%, Y1pos% - 1, ButtonShadow&, -1
Future.LINE X1pos% - 1, Ypos%, X1pos% - 1, Y1pos%, ButtonShadow&, -1
Future.LINE Xpos%, Y1pos%, X1pos%, Y1pos%, ButtonDkShadow&, -1
Future.LINE X1pos%, Ypos%, X1pos%, Y1pos%, ButtonDkShadow&, -1


'Drawing Window Head%
Ypos% = Ypos% + border%
Xpos% = Xpos% + border%: X1pos% = X1pos% - border%
Future.FILLBOX Xpos%, Ypos%, X1pos%, Ypos% + head%, Title&
Future.PRINT Xpos% + 4, Ypos% + (head% / 2) - 7, Title$, TitleText&, -1

CloseButton:
IF win(WinID%).DisableCloseOption% = False% THEN
   Future.FILLBOX ButX, ButY, ButX1, ButY1, ButtonFace&
   Future.LINE ButX, ButY, ButX, ButY1, ButtonHiLight&, -1
   Future.LINE ButX, ButY, ButX1, ButY, ButtonHiLight&, -1
   Future.LINE ButX, ButY1, ButX1, ButY1, ButtonShadow&, -1
   Future.LINE ButX1, ButY, ButX1, ButY1, ButtonShadow&, -1
   Future.PRINT ButX + ButtonSize / 2 - 3, ButY + ButtonSize / 2 - 8, "", ButtonText&, -1
END IF
SetEMSpage 0
END SUB

SUB EndDefBut
IF DefProcess > 0 THEN DefWin ActiveWin%
SetViewPort 0, 0, Xres%, Yres%
END SUB

SUB EndDefWin
'End's window defination process
DefProcess = 0
SetViewPort 0, 0, Xres%, Yres%
END SUB

SUB EndGui
'---EndGui Sub ver 1.0---'
'This routine stops WizGui and Deallocates mamory
ReSetScreen
DeallExpMem ReFresh%
FOR i = 1 TO NofW%
   IF win(i).Status% <> 0 THEN
      DeallocateXMS win(i).BackMask%
      DeallocateXMS win(i).IntMask%
   END IF
NEXT
FreeAllExpMem
SCREEN 0
END SUB

FUNCTION FreeWindow%
'Gives free window id
IF WinCount% < NofW% THEN
   i = 1
   DO
      IF win(i).Status% = 0 THEN
         FreeWindow% = i
         EXIT FUNCTION
      END IF
      i = i + 1
   LOOP UNTIL i > NofW%
END IF
END FUNCTION

SUB GetActiveWindow
'---GetActiveWindow Sub ver: 1.0---'
'This sub get's window ID if mouse button is pressed
'and it's located on the window

FOR i = 1 TO NofW%
   IF win(i).Status% > 0 THEN
      IF MouseX% > win(i).Xpos% AND MouseX% < win(i).X1pos% THEN
         IF MouseY% > win(i).Ypos% AND MouseY% < win(i).Y1pos% THEN
            IF win(i).Order% > CheckOrder THEN
               CheckOrder = win(i).Order%
               SetActive = i
            END IF
         END IF
      END IF
   END IF
NEXT
SetActiveWindow SetActive
END SUB

FUNCTION GetColor& (Number)
'---GetColor Function Ver: 0.5 beta---'
'This sub returns color value from 8 bit color system to any
'other color deph.
IF Deph% = 8 THEN GetColor = Number
 IF Deph% > 8 THEN
   SELECT CASE Number
      CASE 0
         GetColor = 0
      CASE 1
         GetColor = RGB2Color(51, 51, 192)
      CASE 2
         GetColor = RGB2Color(0, 153, 0)
      CASE 3
         GetColor = RGB2Color(51, 204, 255)
      CASE 4
         GetColor = RGB2Color(204, 0, 0)
      CASE 5
         GetColor = RGB2Color(204, 51, 204)
      CASE 6
         GetColor = RGB2Color(153, 153, 0)
      CASE 7
         GetColor = RGB2Color(192, 192, 192)
      CASE 8
         GetColor = RGB2Color(128, 128, 128)
      CASE 9
         GetColor = RGB2Color(102, 255, 255)
      CASE 10
         GetColor = RGB2Color(51, 255, 51)
      CASE 11
         GetColor = RGB2Color(204, 255, 255)
      CASE 12
         GetColor = RGB2Color(255, 102, 102)
      CASE 13
         GetColor = RGB2Color(255, 153, 255)
      CASE 14
         GetColor = RGB2Color(255, 255, 0)
      CASE 15
         GetColor = RGB2Color(255, 255, 255)
   END SELECT
END IF
END FUNCTION

SUB GetMask (Target, WinID%)
'---GetMask Sub ver: 1.1---'
'This sub get's mask from window and behind the window
SELECT CASE Target
   CASE 1
      Future.XMSget WinX(WinID%), WinY(WinID%), WinX1(WinID%), WinY1(WinID%), win(WinID%).BackMask%
   CASE 2
      Future.XMSget X%(WinID%), Y%(WinID%), X1%(WinID%), Y1%(WinID%), win(WinID%).IntMask%
END SELECT
END SUB

SUB HideWindow (WinID%)
'Hides a specific window
IF win(WinID%).Status% > 0 THEN
   IF WinID% <> ActiveWin% THEN
      SAW = ActiveWin%: SetActiveWindow WinID%
      ELSE SAW = 0
   END IF
   GetMask 2, WinID%
   PutMask 1, WinID%
   win(WinID%).Status% = -1
   win(WinID%).Order% = 0
   WinCount% = WinCount% - 1
   ActiveWin% = 0
   SetActiveWindow SAW
END IF
END SUB

SUB HideWindows
'Hides all windows
FOR Count = 1 TO NofW%
   IF win(Count).Status% > 0 THEN HideWindow Count
NEXT
END SUB

SUB Initalise
'---Initalise Sub ver: 1.0---'
'This sub start up WizGui and it's variables
CheckSystem
IF IsMMX <> False% THEN SetMMX 1

SetScreenMode Xres%, Yres%, Deph%
Future.CLS (0)
Load$ = "Loading WizGui ZX..."
Future.PRINT (Xres% / 2) - LEN(Load$) * 4, (Yres% / 2) - 8, Load$, GetColor(2), 0
Xres& = Xres%: Yres& = Yres%
ReFresh% = AllExpMem(Xres& * Yres& * 4)
DefineEMSbufferSize ReFresh%, Xres%, Yres%, 0
SetEMSpage 0
SetLocation Xres% / 2, Yres% / 2
Future.CLS (0)
END SUB

SUB MoveWindow (WinID%)
'---MoveWindow Sub ver. 1.0---'
'This sub move window on the screen when window is beeing dragged
IF win(WinID%).Xpos% <> MouseX% - XChange% OR win(WinID%).X1pos% <> MouseX% + X1Change% OR win(WinID%).Ypos% <> MouseY% - YChange% OR win(WinID%).Y1pos% <> MouseY% + Y1Change% THEN
   IF SWCWD% = True% THEN PutMask 1, WinID%
   win(WinID%).Xpos% = MouseX% - XChange%
   win(WinID%).X1pos% = MouseX% + X1Change%
   win(WinID%).Ypos% = MouseY% - YChange%
   win(WinID%).Y1pos% = MouseY% + Y1Change%
   IF SWCWD% = True% THEN
      GetMask 1, WinID%
      DrawWindow 2, WinID%
      PutMask 2, WinID%
   END IF
   IF SWCWD% = False% THEN
      i = WinID%
      Future.MouseOn
      SetPage 0
      WAIT &H3DA, 8
      WAIT &H3DA, 1, 1
      Future.EMSPut 0, 0, ReFresh%
      MoveColor& = ThemeColor("ButtonShadow")
      Future.PSET win(i).Xpos%, win(i).Ypos%, MoveColor&
      Future.PSET win(i).X1pos%, win(i).Ypos%, MoveColor&
      Future.PSET win(i).Xpos%, win(i).Y1pos%, MoveColor&
      Future.PSET win(i).X1pos%, win(i).Y1pos%, MoveColor&
      Future.LINE win(i).Xpos%, win(i).Ypos%, win(i).X1pos%, win(i).Ypos%, MoveColor&, 32767
      Future.LINE win(i).Xpos%, win(i).Ypos%, win(i).Xpos%, win(i).Y1pos%, MoveColor&, 32767
      Future.LINE win(i).Xpos%, win(i).Y1pos%, win(i).X1pos%, win(i).Y1pos%, MoveColor&, 32767
      Future.LINE win(i).X1pos%, win(i).Ypos%, win(i).X1pos%, win(i).Y1pos%, MoveColor&, 32767
      SetEMSpage 0
      Future.MouseOff
   END IF
EXIT SUB
END IF
END SUB

SUB PaintWin (C&, WinID%)
'Pint's window
IF WinID% = ActiveWin% THEN
   Future.FILLBOX X%(WinID%), Y%(WinID%), X1%(WinID%), Y1%(WinID%), C&
END IF
END SUB

SUB PutMask (Target, WinID%)
'---PutMask Sub ver: 1.1---'
'This routine put's window mask on the window and behind it
SELECT CASE Target
   CASE 1
      Future.XMSput win(WinID%).Xpos%, win(WinID%).Ypos%, win(WinID%).BackMask%
   CASE 2
      Future.XMSput win(WinID%).Xpos% + border%, win(WinID%).Ypos% + head% + border% + border%, win(WinID%).IntMask%
END SELECT
END SUB

SUB ReFreshScreen
'This routine refreshes screen
Future.MouseOn
SetPage 0
Future.EMSPut 0, 0, ReFresh%
SetEMSpage 0
Future.MouseOff
END SUB

SUB ReFreshWindows
'ReFreshes windows, buttons styles, window styles and so on if Theme is changed
IF WinCount% > 0 THEN
   HideWindows
   FOR Count = 1 TO NofW%
      IF win(Count).Status% = -1 THEN
         ShowWindow Count
         SetActiveWindow Count
         IF win(Count).NofB > 0 THEN
            FOR i = 1 TO NofB%
               IF But(Count, i).Status% > 0 THEN DrawButton 1, Count, i
            NEXT
         END IF
         IF win(Count).NofB > 0 THEN
            FOR i = 1 TO NofTb%
               IF Tb(Count, i).Status% > 0 THEN
                  Xpos% = Tb(Count, i).Xpos%
                  Ypos% = Tb(Count, i).Ypos%
                  XSize% = Tb(Count, i).X1pos% - Tb(Count, i).Xpos%
                  YSize% = Tb(Count, i).Y1pos% - Tb(Count, i).Ypos%
                  DrawFillBox3D Xpos%, Ypos%, XSize%, YSize%, 1, ThemeColor("window"), Count
                  Xpos% = Tb(Count, i).Xpos% + X%(Count)
                  Ypos% = Tb(Count, i).Ypos% + Y%(Count)
                  Future.PRINT Xpos% + 4, Ypos% + 4, TbText(Count, i) + " ", ThemeColor("WindowText"), ThemeColor("Window")
               END IF
            NEXT
         END IF
      END IF
   NEXT
END IF
END SUB

SUB RunProcess
'---RunProcess Sub Ver: 0.5 beta---'
'This routine run's all processes in WizGui like pressing buttons,
'moving windows and so on.
'Every process has it's own ID what is defines by variable: InProcess%
'InProcess%:
'  1 - Moves a window
'  2 - Clicks a window close button
'  3 - Do nothing. It comes when Mouse button is clicked, but not on
'      any button, window, textbox or etc. It made to avoid errors
'  4 - Clicks Buttons
'  5 - Textbox system
IF MouseL% = True% AND InProcess% > 0 OR InProcess% = 5 THEN
   SELECT CASE InProcess%
      CASE 1
         MoveWindow ProcessID%
         EXIT SUB
      CASE 2
         ButtonSize = head% - 6
         ButX1 = X1%(ActiveWin%) - 3: ButX = ButX1 - ButtonSize
         ButY = WinY(ActiveWin%) + border% + 3: ButY1 = ButY + ButtonSize
         IF MouseX% > ButX THEN
            IF MouseX% < ButX1 THEN
               IF MouseY% > ButY THEN
                  IF MouseY% < ButY1 THEN
                     DrawWindow 3, ProcessID%
                  END IF
               END IF
            END IF
         END IF
         IF MouseX% < ButX OR MouseX% > ButX1 OR MouseY% < ButY OR MouseY% > ButY1 THEN
            DrawWindow 4, ProcessID%
         END IF
      CASE 4
         WinID% = ActiveWin%
         ButID% = ProcessID%
         Xpos% = But(WinID%, ButID%).Xpos% + X%(WinID%)
         Ypos% = But(WinID%, ButID%).Ypos% + Y%(WinID%)
         X1pos% = But(WinID%, ButID%).Xpos% + X%(WinID%) + But(WinID%, ButID%).XSize%
         Y1pos% = But(WinID%, ButID%).Ypos% + Y%(WinID%) + But(WinID%, ButID%).YSize%
         IF X1pos% > X1%(WinID%) THEN X1pos% = X1%(WinID%)
         IF Y1pos% > Y1%(WinID%) THEN Y1pos% = Y1%(WinID%)
         IF MouseX% > Xpos% THEN
            IF MouseX% < X1pos% THEN
               IF MouseY% > Ypos% THEN
                  IF MouseY% < Y1pos% THEN
                     DrawButton 2, WinID%, ButID%
                  END IF
               END IF
            END IF
         END IF
         IF MouseX% < Xpos% OR MouseX% > X1pos% OR MouseY% < Ypos% OR MouseY% > Y1pos% THEN
            DrawButton 3, WinID%, ButID%
         END IF
      CASE 5
         WinID% = ActiveWin%
         TbID% = ProcessID%
         Text$ = TbText(WinID%, TbID%)
         SELECT CASE key$
            CASE CHR$(33) TO CHR$(255), " "
               IF LEN(Text$) < Tb(WinID%, TbID%).Lenght% THEN
                  Text$ = Text$ + key$
                  TbText(WinID%, TbID%) = Text$
               END IF
            CASE CHR$(8)
               IF LEN(Text$) > 0 THEN
                  TextLenght% = LEN(Text$)
                  Text$ = LEFT$(Text$, TextLenght% - 1)
                  TbText(WinID%, TbID%) = Text$
               END IF
         END SELECT
            Xpos% = Tb(WinID%, TbID%).Xpos% + X%(WinID%)
            Ypos% = Tb(WinID%, TbID%).Ypos% + Y%(WinID%)
            IF Tb(WinID%, TbID%).PasswordType = True THEN
               Text$ = STRING$(LEN(Text$), "*")
            END IF
            IF TextFont$ > "" THEN Future.LoadFONT TextFont$
            Future.PRINT Xpos% + 4, Ypos% + 4, Text$ + "_" + SPACE$(ABS(Tb(WinID%, TbID%).Lenght% - LEN(Text$))), ThemeColor("WindowText"), ThemeColor("Window")
            SetFont 1
   END SELECT
END IF
IF MouseL% = True% AND InProcess% = 5 OR key$ = CHR$(13) AND InProcess% = 5 THEN
   WinID% = ActiveWin%
   TbID% = ProcessID%
   InProcess% = 0
   Text$ = LTRIM$(RTRIM$(TbText(WinID%, TbID%)))
   Tb(WinID%, TbID%).Status% = 1
   Xpos% = Tb(WinID%, TbID%).Xpos% + X%(WinID%)
   Ypos% = Tb(WinID%, TbID%).Ypos% + Y%(WinID%)
   IF Tb(WinID%, TbID%).PasswordType = True THEN
      Text$ = STRING$(LEN(Text$), "*")
   END IF
   IF TextFont$ > "" THEN Future.LoadFONT TextFont$
   Future.PRINT Xpos% + 4, Ypos% + 4, Text$ + " ", ThemeColor("WindowText"), ThemeColor("Window")
   SetFont 1
   ProcessID% = 0
END IF
IF MouseL% = False% AND InProcess% > 0 AND InProcess% <> 5 THEN
   SELECT CASE InProcess%
      CASE 1
         IF SWCWD% = False% THEN
            Future.XMSput OldX%, OldY%, win(ProcessID%).BackMask%
            GetMask 1, ProcessID%
            DrawWindow 2, ProcessID%
            PutMask 2, ProcessID%
         END IF
      CASE 2
         ButtonSize = head% - 6
         ButX1 = X1%(ActiveWin%) - 3: ButX = ButX1 - ButtonSize
         ButY = WinY(ActiveWin%) + border% + 3: ButY1 = ButY + ButtonSize
         IF MouseX% > ButX THEN
            IF MouseX% < ButX1 THEN
               IF MouseY% > ButY THEN
                  IF MouseY% < ButY1 THEN
                     CloseWindow ActiveWin%
                  END IF
               END IF
            END IF
         END IF
      CASE 4
         WinID% = ActiveWin%
         ButID% = ProcessID%
         Xpos% = But(WinID%, ButID%).Xpos% + X%(WinID%)
         Ypos% = But(WinID%, ButID%).Ypos% + Y%(WinID%)
         X1pos% = But(WinID%, ButID%).Xpos% + X%(WinID%) + But(WinID%, ButID%).XSize%
         Y1pos% = But(WinID%, ButID%).Ypos% + Y%(WinID%) + But(WinID%, ButID%).YSize%
         IF X1pos% > X1%(WinID%) THEN X1pos% = X1%(WinID%)
         IF Y1pos% > Y1%(WinID%) THEN Y1pos% = Y1%(WinID%)
         IF MouseX% > Xpos% THEN
            IF MouseX% < X1pos% THEN
               IF MouseY% > Ypos% THEN
                  IF MouseY% < Y1pos% THEN
                     DrawButton 3, WinID%, ButID%
                     But(WinID%, ButID%).Status% = 2
                     TempWinID% = WinID%
                     TempControlID% = ButID%
                     TempControlType% = 4
                  END IF
               END IF
            END IF
         END IF
         IF MouseX% < Xpos% OR MouseX% > X1pos% OR MouseY% < Ypos% OR MouseY% > Y1pos% THEN
            DrawButton 3, WinID%, ButID%
            But(WinID%, ButID%).Status% = 1
         END IF
   END SELECT
   InProcess% = 0
   ProcessID% = 0
END IF

END SUB

SUB RunSystem
'---Run System Sub Ver: 0.9---'
'This sub run's WizGui and it's components
'Controls - detects mouse and keyboard activitys
'ReFreshScreen - As name says it refreshes screen
'WindowControls - An routine what makes using windows easer.
'              By pressing F4 - you can simply close active window
'              or by pressing Tabulator you can simply swich between windows
IF TempWinID% > 0 THEN
   SELECT CASE TempControlType%
      CASE 4
         But(TempWinID%, TempControlID%).Status = 1
   END SELECT
   TempWinID% = 0
   TempControlID% = 0
   TempControlType% = 0
END IF
Controls
IF InProcess% > 0 THEN RunProcess
IF InProcess% = 1 AND SWCWD% = False% THEN EXIT SUB
IF MouseL% = True% AND InProcess% = False% OR InProcess% = 3 THEN
   DetectProcess
END IF
IF key$ > "" AND InProcess% = 0 THEN WindowControls
ReFreshScreen
END SUB

SUB SetActiveWindow (WinID%)
'---SetActiveWindow Sub Ver 1.0---'
'This routine set's active window bywindow ID and bring's it to the front.
IF WinID% = 0 THEN
   IF ActiveWin% > 0 THEN
      i = ActiveWin%
      GetMask 2, i
      DrawWindow 1, i
      PutMask 2, i
      ActiveWin% = 0
   END IF
   EXIT SUB
END IF
FOR i = 1 TO NofW%
   IF win(i).Status% > 0 THEN
      Order = win(i).Order%
      WinDataBase(Order) = i
      Count = Count + 1
   END IF
NEXT
FOR i = Count TO 1 STEP -1
   GetMask 2, WinDataBase(i)
   PutMask 1, WinDataBase(i)
NEXT

Order = 0
FOR i = 1 TO Count
   IF WinDataBase(i) <> WinID% THEN
      Order = Order + 1
      idd = WinDataBase(i)
      GetMask 1, idd
      win(idd).Status% = 1
      DrawWindow 1, idd
      PutMask 2, idd
      win(idd).Order% = Order
   END IF
NEXT
GetMask 1, WinID%
win(WinID%).Status% = 2
DrawWindow 2, WinID%
PutMask 2, WinID%
win(WinID%).Order% = WinCount%
ActiveWin% = WinID%
END SUB

SUB SetAdvButton (Xpos%, Ypos%, XSize%, YSize%, Title$, WinID%, ButID%)
'Defines any size button
IF WinID% = ActiveWin% THEN
   IF ButID% < 1 THEN EXIT SUB
   IF But(WinID%, ButID%).Status% > 0 THEN EXIT SUB
   But(WinID%, ButID%).XSize% = XSize%
   But(WinID%, ButID%).YSize% = YSize%
   SetButton Xpos%, Ypos%, Title$, WinID%, ButID%
END IF
END SUB

SUB SetButton (Xpos%, Ypos%, Title$, WinID%, ButID%)
'This routine defines and creates new button
IF WinID% = ActiveWin% THEN
   IF ButID% < 1 THEN EXIT SUB
   IF But(WinID%, ButID%).Status% > 0 THEN EXIT SUB
   But(WinID%, ButID%).Xpos% = Xpos%
   But(WinID%, ButID%).Ypos% = Ypos%
   IF But(WinID%, ButID%).XSize% = 0 THEN
      IF LEN(Title$) <= 11 THEN But(WinID%, ButID%).XSize% = 12 * 8
      IF LEN(Title$) > 11 THEN
         But(WinID%, ButID%).XSize% = LEN(Title$) * 8 + 8
      END IF
   END IF
   IF But(WinID%, ButID%).YSize% = 0 THEN But(WinID%, ButID%).YSize% = 22
   But(WinID%, ButID%).Status% = 1
   But(WinID%, ButID%).WinID% = WinID%
   But(WinID%, ButID%).Status% = 1
   ButText(WinID%, ButID%) = Title$
   win(WinID%).NofB = win(WinID%).NofB + 1
   DrawButton 1, WinID%, ButID%

   'TextX = X%(WinID%) + Xpos%
   'TextX = TextX + (But(WinID%, ButID%).XSize% / 2)
   'TextX = TextX - LEN(Title$) * 4
   'TextY = Y%(WinID%) + Ypos%
   'TextY = TextY + (But(WinID%, ButID%).YSize% / 2)
   'TextY = TextY - 7
   'Future.PRINT TextX, TextY, Title$, ThemeColor("ButtonText"), -1
END IF

END SUB

SUB SetSmartText (Text$)
'Smart text is text wraping in the window.
IF ActiveWin% = CursorWinID% THEN
   IF SmTXpos% = 0 THEN SmTXpos% = 0
   IF SmTX1pos% = 0 THEN SmTX1pos% = WinXSize%(CursorWinID%)
   IF CursorX% >= SmTX1pos% THEN
      CursorX% = SmTXpos%
      CursorY% = CursorY% + 16
   END IF
   IF CursorX% < SmTXpos% THEN CursorX% = SmTXpos%
   TextAreaLenght = SmTX1pos% - SmTXpos% + 14
   DO
      BufferLenght = INT((TextAreaLenght / 8) - (CursorX% / 8))
      Buffer$ = LEFT$(Text$, BufferLenght)
      ScSize = 10
      SC = 0
      SpacePosition = 0
      Buffer$ = RTRIM$(Buffer$)
      IF LEN(Buffer$) >= BufferLenght THEN
         DO
            IF SC >= LEN(Buffer$) THEN EXIT DO
            SpacePosition = INSTR((LEN(Buffer$) - SC), Buffer$, " ")
            IF SpacePosition > 0 THEN EXIT DO
            SC = SC + 1
         LOOP UNTIL SC >= ScSize
      END IF
      IF SpacePosition > 0 THEN
         Buffer$ = LEFT$(Buffer$, SpacePosition - 1)
      END IF
      SetText Buffer$
      Text$ = MID$(Text$, LEN(Buffer$) + 2)
      CursorX% = SmTXpos%
   LOOP UNTIL LEN(Text$) <= 0
END IF
END SUB

SUB SetSmartTextArea (Xpos%, X1pos%, WinID%)
'Specifies SmartText wraping window size. If not specified then window actual
'size is in use.
SmTXpos% = Xpos%
IF X1pos% - Xpos% < WinXSize%(WinID%) THEN
   SmTX1pos% = X1pos%
   ELSE SmTX1pos% = WinXSize%(WinID%)
END IF
END SUB

SUB SetText (Text$)
'Print's text to the window
IF TextFgColor& = -1 THEN
   TextFgColor& = ThemeColor("WindowText")
END IF
IF ActiveWin% = CursorWinID% THEN
   IF TextFont$ > "" THEN Future.LoadFONT TextFont$
   Future.PRINT CursorX% + X%(CursorWinID%), CursorY% + Y%(CursorWinID%), Text$, TextFgColor&, TextBgColor&
   CursorY% = CursorY% + 16
   SetFont 1
END IF
END SUB

SUB SetTextBox (Xpos%, Ypos%, Lenght%, WinID%, TbID%)
IF WinID% = ActiveWin% THEN
   XSize% = Lenght% * 8 + 16
   YSize% = 20
   X1pos% = Xpos% + XSize%
   Y1pos% = Ypos% + YSize%
   Tb(WinID%, TbID%).Status% = 1
   Tb(WinID%, TbID%).Xpos% = Xpos%
   Tb(WinID%, TbID%).Ypos% = Ypos%
   Tb(WinID%, TbID%).X1pos% = X1pos%
   Tb(WinID%, TbID%).Y1pos% = Y1pos%
   Tb(WinID%, TbID%).WinID% = WinID%
   TbText(WinID%, TbID%) = ""
   Tb(WinID%, TbID%).Lenght% = Lenght%
   win(WinID%).NofTb = win(WinID%).NofTb + 1
   DrawFillBox3D Xpos%, Ypos%, XSize%, YSize%, 1, ThemeColor("window"), WinID%
END IF

END SUB

SUB SetTextColor (FColor&, BColor&)
'Set Text color(like COLOR statament)
TextBgColor& = BColor&
TextFgColor& = FColor&
END SUB

SUB SetTextFont (File$)
IF File$ > "" THEN
   TextFont$ = File$
   ELSE SetFont 1: TextFont$ = ""
END IF
END SUB

SUB SetTextLoc (Xpos%, Ypos%, WinID%)
'Set Cursor location in specific window
CursorX% = Xpos%
CursorY% = Ypos%
CursorWinID% = WinID%
END SUB

SUB SetWindow (Xpos%, Ypos%, XSize%, YSize%, Title$, WinID%)
'---SetWindow Sub Ver 1.0---'
'This sub set's a new window what is define by Xpos%, Ypos% and XSize% and YSize%
'Every window MUST have a diffrent window ID (WinID%).

IF win(WinID%).Status% <> 0 THEN EXIT SUB
IF WinCount% = NofW% THEN EXIT SUB
IF XSise% > Xres% OR Yres% > Yres% THEN EXIT SUB

IF ActiveWin% > 0 THEN SAW = ActiveWin%: SetActiveWindow 0
IF XSize% < 60 THEN EXIT SUB
IF YSize% < 30 THEN EXIT SUB
IF Xpos% < 0 THEN Xpos% = Xpos% * -1
IF Ypos% < 0 THEN Ypos% = Ypos% * -1
X1pos% = Xpos% + XSize%
Y1pos% = Ypos% + YSize%
XSize& = ABS(XSize%)
YSize& = ABS(YSize%)
IF FreeXMSmemory <= 8 * (XSize& * YSize%) THEN EXIT SUB
win(WinID%).BackMask% = AllocateXMS((XSize& * YSize& + XSize& + YSize&) * (Deph% / 8))
XSize& = XSize% - 2 * border%
YSize& = XSize% - 2 * border% - head%
win(WinID%).IntMask% = AllocateXMS((XSize& * YSize& + XSize& + YSize&) * (Deph% / 8))

WinCount% = WinCount% + 1
win(WinID%).Order% = WinCount%
win(WinID%).Status% = 1
win(WinID%).Xpos% = Xpos%
win(WinID%).Ypos% = Ypos%
win(WinID%).X1pos% = X1pos%
win(WinID%).Y1pos% = Y1pos%
win(WinID%).Title = Title$
win(WinID%).WinID% = WinID%
IF win(WinID%).DisableCloseOption% = False% THEN win(WinID%).DisableCloseOption = False%
GetMask 1, WinID%
DrawWindow 1, WinID%
GetMask 2, WinID%
IF SAW > 0 THEN SetActiveWindow SAW
END SUB

SUB ShowWindow (WinID%)
'shows specific hidden window
IF win(WinID%).Status% = -1 THEN
   IF ActiveWin% > 0 THEN SAW = ActiveWin%: SetActiveWindow 0
   win(WinID%).Status% = 1
   WinCount% = WinCount% + 1
   win(WinID%).Order% = WinCount%
   GetMask 1, WinID%
   DrawWindow 1, WinID%
   PutMask 2, WinID%
   SetActiveWindow SAW
END IF
END SUB

SUB ShowWindows
'Shows all hidden windows
FOR Count = 1 TO NofW%
   IF win(Count).Status% = -1 THEN ShowWindow Count
NEXT
END SUB

SUB TextBoxSystem
IF ActiveWin% > 0 THEN
   IF win(ActiveWin%).NofTb = 0 THEN EXIT SUB
   FOR i = 1 TO NofTb%
      IF Tb(ActiveWin%, i).Status% > 0 THEN
         IF Tb(ActiveWin%, i).WinID% = ActiveWin% THEN
            id = ActiveWin%
            IF MouseX% > Tb(id, i).Xpos% + X%(id) THEN
               IF MouseX% < Tb(id, i).X1pos% + X%(id) THEN
                  IF MouseY% > Tb(id, i).Ypos% + Y%(id) THEN
                     IF MouseY% < Tb(id, i).Y1pos% + Y%(id) THEN
                        InProcess% = 5
                        ProcessID% = i
                        Text$ = LTRIM$(RTRIM$(TbText(id, i)))
                        Xpos% = Tb(id, i).Xpos% + X%(id)
                        Ypos% = Tb(id, i).Ypos% + Y%(id)
                        IF Tb(id, i).PasswordType = True THEN
                           Text$ = STRING$(LEN(Text$), "*")
                        END IF
                        IF TextFont$ > "" THEN Future.LoadFONT TextFont$
                        Future.PRINT Xpos% + 4, Ypos% + 4, Text$ + "_", ThemeColor("WindowText"), ThemeColor("window")
                        SetFont 1
                        Tb(id, i).Status% = 2
                        EXIT SUB
                     END IF
                  END IF
               END IF
            END IF
         END IF
      END IF
   NEXT
END IF
END SUB

FUNCTION ThemeColor& (Unit$)
Unit$ = LCASE$(Unit$)
IF Deph% >= 8 AND Theme$ > "" THEN
   File = FREEFILE
   OPEN Theme$ FOR INPUT AS File
      DO
         INPUT #File, Buffer$, R, G, B
         Buffer$ = LCASE$(Buffer$)
      LOOP UNTIL Buffer$ = Unit$
   CLOSE File
ThemeColor& = RGB2Color(R, G, B)
END IF
IF Deph% = 8 OR Theme$ = "" THEN
   SELECT CASE Unit$
      CASE "inactiveborder"
         ThemeColor& = GetColor(7)
      CASE "activeborder"
         ThemeColor& = GetColor(7)
      CASE "buttonface"
         ThemeColor& = GetColor(7)
      CASE "buttonshadow"
         ThemeColor& = GetColor(8)
      CASE "buttonhilight"
         ThemeColor& = GetColor(15)
      CASE "buttonlight"
         ThemeColor& = GetColor(7)
      CASE "buttondkshadow"
         ThemeColor& = GetColor(0)
      CASE "buttontext"
         ThemeColor& = GetColor(0)
      CASE "windowtext"
         ThemeColor& = GetColor(0)
      CASE "activetitle"
         ThemeColor& = GetColor(1)
      CASE "inactivetitle"
         ThemeColor& = GetColor(8)
      CASE "titletext"
         ThemeColor& = GetColor(15)
      CASE "inactivetitletext"
         ThemeColor& = GetColor(7)
      CASE "window"
         ThemeColor& = GetColor(15)
   END SELECT
END IF

END FUNCTION

SUB WindowControls
SELECT CASE key$
   CASE CHR$(9)
      IF WinCount% > 0 THEN
         SELECT CASE ActiveWin%
            CASE 0
               NextActiveWin = WinCount%
               DO
                  Count = Count + 1
                  IF Count > NofW% THEN EXIT SUB
                  IF win(Count).Status% = -1 THEN Count = Count + 1
                  IF Count > NofW% THEN EXIT SUB
                  IF win(Count).Order% = NextActiveWin THEN
                     IF win(Count).Status% > 0 THEN EXIT DO
                  END IF
               LOOP
               SetActiveWindow Count
            CASE IS > 0
               NextActiveWin = 1
               DO
                  Count = Count + 1
                  IF Count > NofW% THEN EXIT SUB
                  IF win(Count).Status% = -1 THEN Count = Count + 1
                  IF Count > NofW% THEN EXIT SUB
                  IF win(Count).Order% = NextActiveWin THEN
                     IF win(Count).Status% > 0 THEN EXIT DO
                  END IF
               LOOP
               SetActiveWindow Count
            END SELECT
      END IF
   CASE CHR$(0) + CHR$(62)
      IF ActiveWin% > 0 AND win(ActiveWin%).DisableCloseOption% = False% THEN CloseWindow ActiveWin%
END SELECT
END SUB

SUB WindowSystem
'Detect if mouse is pressed on the title bar or window close button.
'IF yes THEN returns InProgress value 2 or 1
IF ActiveWin% > 0 THEN
   Xpos% = WinX(ActiveWin%)
   Ypos% = WinY(ActiveWin%)
   X1pos% = WinX1(ActiveWin%)
   Y1pos% = WinY1(ActiveWin%)
   IF MouseX% > Xpos% THEN
      IF MouseX% < X1pos% THEN
         IF MouseY% > Ypos% THEN
            IF MouseY% < Y1pos% THEN
               Xpos% = X%(ActiveWin%)
               Ypos% = WinY(ActiveWin%) + border%
               X1pos% = X1%(ActiveWin%)
               Y1pos% = Y%(ActiveWin%) - border%
               IF MouseX% > Xpos% THEN
                  IF MouseX% < X1pos% THEN
                     IF MouseY% > Ypos% THEN
                        IF MouseY% < Y1pos% THEN
                           IF win(ActiveWin%).DisableCloseOption% = False% THEN
                              ButtonSize = head% - 6
                              ButX1 = X1%(ActiveWin%) - 3: ButX = ButX1 - ButtonSize
                              ButY = WinY(ActiveWin%) + border% + 3: ButY1 = ButY + ButtonSize
                              IF MouseX% > ButX THEN
                                 IF MouseX% < ButX1 THEN
                                    IF MouseY% > ButY THEN
                                       IF MouseY% < ButY1 THEN
                                          InProcess% = 2
                                          ProcessID% = ActiveWin%
                                          EXIT SUB
                                       END IF
                                    END IF
                                 END IF
                              END IF
                           END IF
                           Xpos% = WinX(ActiveWin%)
                           Ypos% = WinY(ActiveWin%)
                           X1pos% = WinX1(ActiveWin%)
                           Y1pos% = WinY1(ActiveWin%)
                           InProcess% = 1
                           ProcessID% = ActiveWin%
                           OldX% = Xpos%: OldY% = Ypos%
                           XChange% = MouseX% - Xpos%: YChange% = MouseY% - Ypos%
                           X1Change% = X1pos% - MouseX%: Y1Change% = Y1pos% - MouseY%
                           GetMask 2, ProcessID%
                           EXIT SUB
                        END IF
                     END IF
                  END IF
               END IF
            END IF
         END IF
      END IF
   END IF
END IF
GetActiveWindow
END SUB

FUNCTION WinX (WinID%)
WinX = win(WinID%).Xpos%
END FUNCTION

FUNCTION WinX1 (WinID%)
WinX1 = win(WinID%).X1pos%
END FUNCTION

FUNCTION WinXSize% (WinID%)
WinXSize% = X1%(WinID%) - X%(WinID%)
END FUNCTION

FUNCTION WinY (WinID%)
WinY = win(WinID%).Ypos%
END FUNCTION

FUNCTION WinY1 (WinID%)
WinY1 = win(WinID%).Y1pos%
END FUNCTION

FUNCTION WinYSize% (WinID%)
WinYSize% = Y1%(WinID%) - Y%(WinID%)
END FUNCTION

FUNCTION WizGuiCodeName$
'Gives WizGui code name
WizGuiCodeName$ = "WizGui ZX"
END FUNCTION

FUNCTION WizGuiVersion$
'Gives WizGui verion
WizGuiVersion$ = "1.5"
END FUNCTION

FUNCTION X (WinID%)
X = win(WinID%).Xpos% + border%
END FUNCTION

FUNCTION X1 (WinID%)
X1 = WinX1(WinID%) - border%
END FUNCTION

FUNCTION Y (WinID%)
Y = WinY(WinID%) + 2 * border% + head%
END FUNCTION

FUNCTION Y1 (WinID%)
Y1 = WinY1(WinID%) - border%
END FUNCTION

